<?php
/**
* Web based SQLite management
* Some functions
* @package SQLiteManager
* @author Frdric HENNINOT
* @version $Id: common.lib.php,v 1.36 2004/04/29 06:09:52 freddy78 Exp $ $Revision: 1.36 $
*/

/**
* sqlite_query wrapper function
*/
function SQLiteExecFunction($db, $query){
	if(substr(trim($query), -1) != ";") $query .= ";";
	if(DEBUG) return sqlite_query($db, $query);
	else return @sqlite_query($db, $query);
}

/**
* sqlite_num_rows wrapper function
*/
function SQLiteNumFunction($res){
	if(DEBUG) return sqlite_num_rows($res);
	else return @sqlite_num_rows($res);
}

/**
* sqlite_fetch_array wrapper function
*/
function SQLiteFetchFunction($res, $type=SQLITE_ASSOC){
	if(DEBUG) return sqlite_fetch_array($res, $type);
	else return @sqlite_fetch_array($res, $type);
}

/**
* sqlite_num_fields wrapper function
*/
function SQLiteNumFieldsFunction($res){
	if(DEBUG) return sqlite_num_fields($res);
	else return @sqlite_num_fields($res);
}

/**
* sqlite_field_name wrapper function
*/
function SQLiteFieldNameFunction($res, $i){
	if(DEBUG) return sqlite_field_name($res, $i);
	else return @sqlite_field_name($res, $i);
}

/**
* sqlite_array_query wrapper function
*/
function SQLiteArrayFunction($db, $query, $type=SQLITE_ASSOC){
	if(DEBUG) return sqlite_array_query($db, $query, $type);
	else return @sqlite_array_query($db, $query, $type);
}

/**
* sqlite_fetch_string wrapper function
*/
function SQLiteStringFunction($res){
	if(DEBUG) return sqlite_fetch_string($res);
	else return @sqlite_fetch_string($res);
}

/**
* check if SQLite extension is loaded, and if not load it.
*/
function SQLIteCheckOk(){
	$SQL_SERVER_OS = strtoupper(substr(PHP_OS, 0, 3));
	if(substr(phpversion(), 0, 1) == "5") $extName = "sqlite";
	elseif($SQL_SERVER_OS == "LIN") $extName = "sqlite.so";
	elseif($SQL_SERVER_OS == "WIN") $extName = "php_sqlite";
	if (!extension_loaded($extName) && !in_array("sqlite", get_loaded_extensions())) {
    	if (dl($extName)) {
    	    return true;
    	} else {
			return false;
		}
	} else return true;
}

/**
* Display error message
* 
* @param string $message 
*/
function displayError($message){
	echo '
	<center>
		<table width="80%" style="border: 1px solid red">
			<tr><td align="center"><b>'.$GLOBALS["traduct"]->get(9).' :</b></td></tr>
			<tr><td align="left"><span style="color: red"><b>'.$message.'</b></span></td></tr>
		</table>
	</center>';
	return;
}

/**
* Display the global menu on the right pan, it' dependant of context
*/
function displayMenuTitle(){
	$linkBase = "main.php?dbsel=".$GLOBALS["dbsel"];
	foreach($GLOBALS["dbItems"] as $Items) if(isset($GLOBALS[strtolower($Items)])) $linkBase .= "&".strtolower($Items)."=".$GLOBALS[strtolower($Items)];
	echo "	<div align=\"center\">
				<table width=80% style=\"border-bottom: 1px solid black\">
					<tr>
						<td width=10%>&nbsp;</td>";
	if(isset($GLOBALS["table"]) && ($GLOBALS["table"]!="")){
		echo "
						<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=browseItem\" target=\"main\">".$GLOBALS["traduct"]->get(73)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=insertElement\" target=\"main\">".$GLOBALS["traduct"]->get(75)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=export\" target=\"main\">".$GLOBALS["traduct"]->get(76)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(79)."')) top.main.location='".$linkBase."&action=empty';\">".$GLOBALS["traduct"]->get(77)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(80)."')) top.main.location='".$linkBase."&action=delete';\">".$GLOBALS["traduct"]->get(15)."</a></td>";
	} elseif(isset($GLOBALS["view"]) && ($GLOBALS["view"]!="")) {
		echo "
						<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=browseItem\" target=\"main\">".$GLOBALS["traduct"]->get(73)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=export\" target=\"main\">".$GLOBALS["traduct"]->get(76)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=add\" target=\"main\">".$GLOBALS["traduct"]->get(81)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(82)."')) top.main.location='".$linkBase."&action=delete';\">".$GLOBALS["traduct"]->get(15)."</a></td>";
	} elseif(isset($GLOBALS["function"]) && ($GLOBALS["function"]!="")) {
		echo "
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=export\" target=\"main\">".$GLOBALS["traduct"]->get(76)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=add\" target=\"main\">".$GLOBALS["traduct"]->get(81)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(78)."')) top.main.location='".$linkBase."&action=delete';\">".$GLOBALS["traduct"]->get(15)."</a></td>";
	} elseif(isset($GLOBALS["trigger"]) && ($GLOBALS["trigger"]!="")) {
		echo "
						<td class=\"proptitle\" align=\"center\" width=20%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=20%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=20%><a class=\"titleHeader\" href=\"".$linkBase."&action=add\" target=\"main\">".$GLOBALS["traduct"]->get(81)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=20%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(83)."')) top.main.location='".$linkBase."&action=delete';\">".$GLOBALS["traduct"]->get(15)."</a></td>";
	} else {
		echo "
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=options\" target=\"main\">".$GLOBALS["traduct"]->get(84)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=export\" target=\"main\">".$GLOBALS["traduct"]->get(76)."</a></td>
						<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(85)."')) top.main.location='".$linkBase."&action=del';\">".$GLOBALS["traduct"]->get(86)."</a></td>";
	}
	
	echo "				<td width=10%>&nbsp;</td>
					</tr>
				</table>
			</div>";
}

/**
* Display pan header
*
* @param string $frame target where the header will be display
* @param bool $withTitle display title
*/
function displayHeader($frame, $withTitle=true){
	?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
	<head>
	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="expires" content="0">	<meta http-equiv="content-type" content="text/html;charset=<?php echo $GLOBALS["charset"] ?>">	
	<link href="theme/<?php echo $GLOBALS["localtheme"]."/".$frame ?>.css" rel="stylesheet" type="text/css">
	<script src="include/function.js" type="text/javascript" language="javascript"></script>
	</head>

	<body>
	<?php
	if( ($frame == "main") && ($withTitle) && ($GLOBALS["dbsel"]) ){
		echo "<h2>".$GLOBALS["traduct"]->get(131)." : <a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."\" style=\"text-decoration: none\"><span style='color: red'>".$GLOBALS["tabInfoDb"]["name"]."</span></a>";
		foreach($GLOBALS["dbItems"] as $Items) {
			if(!empty($GLOBALS[strtolower($Items)])) echo " - ".$GLOBALS["itemTranslated"][$Items]." <a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&".strtolower($Items)."=".$GLOBALS[strtolower($Items)]."\" style=\"text-decoration: none\"><span style='color: blue'>".$GLOBALS[strtolower($Items)]."</span></a>";		
		}
		echo "</h2>\n";
	}
}

/**
* Display add form dependent of context
*
* @param string $type represent the context
*/
function formAddItem($type){
	switch($type){
		case "Table":
			echo "<form name=\"add".$type."\" method=\"POST\"><span style='font-size: 12px'>".$GLOBALS["traduct"]->get(43)." ==>&nbsp;".$GLOBALS["traduct"]->get(19)." : <input type=\"text\" name=\"TableName\" size=20 class=\"small-input\"> - <input type=\"text\" name=\"nbChamps\" size=3 class=\"small-input\">&nbsp;".$GLOBALS["traduct"]->get(44)."&nbsp;<input type=\"submit\" value=\"".$GLOBALS["traduct"]->get(69)."\"><input type=\"hidden\" name=\"dbsel\" value=\"".$GLOBALS["dbsel"]."\"><input type=\"hidden\" name=\"action\" value=\"add_".strtolower($type)."\"></span></form>";
			break;
		case "View":
			echo "<a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&action=add_view\" class='propItemTitle'>&nbsp;&raquo;&nbsp;".$GLOBALS["traduct"]->get(87)."</a>";
			break;
		case "Trigger":
			echo "<a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&action=add_trigger\" class='propItemTitle'>&nbsp;&raquo;&nbsp;".$GLOBALS["traduct"]->get(88)."</a>";
			break;
		case "Function":
			echo "<a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&action=add_function\" class='propItemTitle'>&nbsp;&raquo;&nbsp;".$GLOBALS["traduct"]->get(89)."</a>";
			break;
	}
}

/**
* Display query has been execute
*
* @param string $query
* @param bool $withLink if true some links will be display
*/
function displayQuery($query, $withLink=true){
	if(empty($query)) $query = $GLOBALS["DisplayQuery"];
	$linkBase = "main.php?dbsel=".$GLOBALS["dbsel"]."&table=".$GLOBALS["table"];
	if($posLim = strpos($query, "LIMIT")) {
		$queryLink = substr($query, 0, ($posLim-1));
	} else $queryLink = $query;
	if(isset($GLOBALS["DbGrid"]) && is_object($GLOBALS["DbGrid"])){
		if(!empty($GLOBALS["DbGrid"]->infoNav["start"]) || !empty($GLOBALS["DbGrid"]->infoNav["end"]) || !empty($GLOBALS["DbGrid"]->infoNav["all"])){
			$infoNav = "<span style=\"font-size: 12px\">".$GLOBALS["traduct"]->get(136)." ".$GLOBALS["DbGrid"]->infoNav["start"]."-".$GLOBALS["DbGrid"]->infoNav["end"]."/".$GLOBALS["DbGrid"]->infoNav["all"]."&nbsp;&nbsp;</span>";
		}
	}
	if(!isset($infoNav)) $infoNav = "";
	echo "
		<table width=60% align=\"center\" style='margin-top: 10px'>
			<tr><td bgcolor=\"".$GLOBALS["displayQueryTitleColor"]."\" >".$GLOBALS["traduct"]->get(90)." : ".(($withLink)? "&nbsp;&nbsp;".$infoNav."[<a href=\"".$linkBase."&action=sql&sql_action=modify&displayResult=&DisplayQuery=".urlencode($queryLink)."\">".$GLOBALS["traduct"]->get(14)."</a>]" : "" )."</td></tr>
			<tr><td bgcolor=\"".$GLOBALS["displayQueryBgColor"]."\" nowrap=\"nowrap\"><div class=\"sqlsyntaxe\">".highlight_query($query)."</div></td></tr>
		</table><br>
		";
}

/**
* highlight query for a proch future!!
*/
function highlight_query($query){
	include_once INCLUDE_LIB."ParsingQuery.class.php";
	$Colorize =& new ParsingQuery($query, 1);
	$Colorize->explodeQuery();
	$Colorize->colorWordList();
	return $Colorize->highlightQuery();
}

/**
* Display function list for the insert / modify form
*
* @param string $champ name of the current champ
*/
function SQLiteFunctionList($champ, $userDefine=""){
	$out = "<select name='funcs[".$champ."]'>\n
				<option value=''></option>\n";
	foreach($GLOBALS["SQLfunction"] as $funct) $out .= "<option value='".$funct."'>".$funct."</option>\n";	
	$tabUDF = $GLOBALS["workDb"]->functInfo;
	$out .= "<option value=''></option>\n";	
	if(is_array($tabUDF)) foreach($tabUDF as $udfInfo) if($udfInfo["funct_type"]==1) $out .= "<option value='".$udfInfo["funct_name"]."'>".$udfInfo["funct_name"]."</option>";
	$out .= "</select>";
	return $out;
}

/**
* Display input TYPE for the insert / modify form
*
* @param array $info data info for the current champ
* @param mixed $data current value of the champ
*/
function SQLiteInputType($info, $data){
	static $tabIndex;
	if(empty($tabIndex)) $tabIndex = 1;
	if( (substr($info["type"],0,4)=="CHAR") || (substr($info["type"],0,7)=="VARCHAR") ) {
		preg_match("/\((.*)\)/", $info["type"], $length);
		if($length[1]){		
			$maxlength = "maxlength=".$length[1];
			if($length[1]<=20) $maxlength = " size=".($length[1]+1)." ".$maxlength;
		} else $maxlength = " size=20";
	} else $maxlength = " size=20";
	if($info["notnull"] && ($data == '')){
		if(strstr($info["type"], "(")) {
			$localType = trim(preg_replace("/\(.*\)/", "", $info["type"]));
		} else {
			$localType = $info["type"];
		}
		if($info["dflt_value"]!= "") $data = $info["dflt_value"];
		elseif(isset($GLOBALS["SQLiteType"][$localType])) $data=$GLOBALS["SQLiteType"][$localType];
	}
	if((strtoupper(substr($info["type"],0,4))!="TEXT") && (strtoupper(substr($info["type"],0,4))!="BLOB")) $out = "<input type=\"text\" name=\"valField[".$info["name"]."]\" value=\"".$data."\"".$maxlength." tabindex=".($tabIndex++).((!$info["notnull"])? " onChange=\"if(this.value!='') setCheckBox('editElement', 'nullField[".$info["name"]."]', false); else setCheckBox('editElement', 'nullField[".$info["name"]."]', true);\"" : "" ).">";
	else $out = "<textarea name=\"valField[".$info["name"]."]\" cols=".$GLOBALS["textareaCols"]." rows=".$GLOBALS["textareaRows"]." tabindex=".($tabIndex++).((!$info["notnull"])? " onChange=\"if(this.value!='') setCheckBox('editElement', 'nullField[".$info["name"]."]', false); else setCheckBox('editElement', 'nullField[\'".$info["name"]."\']', true);\"" : "" ).">".$data."</textarea>";
	return $out;
}

/**
* Return Available language
*/
function getAvailableLanguage(){
	$out = "";
	natsort($GLOBALS["availableLangue"]);
	while(list($lgId, $lgLib) = each($GLOBALS["availableLangue"])){
		$out .= "<option value=\"".$lgId."\"".(($GLOBALS["currentLangue"]==$lgId)? " selected" : "" ).">".$GLOBALS["langueTranslated"][$lgId]."</option>\n";
	}
	return $out;
}

/**
*
*/
function getAvailableTheme(){
	$out = "";
	natsort($GLOBALS["availableTheme"]);
	while(list($themeId, $themeLib) = each($GLOBALS["availableTheme"])){
		$out .= "<option value=\"".$themeId."\"".(($GLOBALS["localtheme"]==$themeId)? " selected" : "" ).">".$themeLib."</option>\n";
	}
	return $out;
}

/**
*
*/
function applyFunction($function, $value){
	$newValue = $value;
	if(in_array($function, $GLOBALS["SQLfunction"])){
		if($function == "MD5") $newValue = "php('md5', '$value')";
		elseif($function == "NOW") $newValue = "php('date', 'Y-m-d')";
		else $newValue = strtolower($function)."($value)";
	} else {
		foreach($GLOBALS["workDb"]->functInfo as $functInfo) {
			if($function == $functInfo["funct_name"]) $newValue = $function."($value)";
		}
	}
	return $newValue;
}

function arrayToGet($tab){
	$strOut = array();
	while(list($var, $value) = each($tab)) $strOut[] = $var."=".$value;
	return implode("&", $strOut);	
}

/**
*
*/
function cleanFieldName($string, $allow = "a-z_0-9"){
	return eregi_replace("[^".$allow."]", "", $string);
}

/**
*
*/
function strpos_all($string, $separator){
	static $tabPos=array();
	$pos = strpos($string, $separator);
	if((string)$pos!=""){
	if(count($tabPos)>=1) $addPrec = ($tabPos[count($tabPos)-1] +1);
	else $addPrec = 0;
		array_push($tabPos, ($pos + $addPrec));
		$substring = substr($string, ($pos + 1), (strlen($string) - ($pos+1)) );
		strpos_all($substring, $separator);		
	}
	return $tabPos;
}

?>
